package com.repair.controller;


import com.repair.api.RepairTransferRecordControllerAPI;
import com.repair.common.utils.paramUtils;
import com.repair.model.pojo.RepairTransferRecord;
import com.repair.model.result.CommonResult;
import com.repair.model.result.PageUtils;
import com.repair.services.RepairTransferRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-07-20
 */
@RestController
public class RepairTransferRecordController implements RepairTransferRecordControllerAPI {

    @Autowired
    private RepairTransferRecordService repairTransferRecordService;

    /**
     * 新增转单审核记录
     * @param rc 转单审核数据
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult insertRepairTransferRecord(RepairTransferRecord rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairTransferRecordService.insertRepairTransferRecord(rc);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 更新转单审核数据
     * @param rc 转单审核数据
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult updateRepairTransferRecordById(RepairTransferRecord rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairTransferRecordService.updateRepairTransferRecord(rc);

        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 转单审核分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageRepairTransferRecords(int currentPage, int pageCount, String name) {
        PageUtils<RepairTransferRecord> result = repairTransferRecordService.queryPageRepairTransferRecords(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }

    /**
     * 根据数据ID删除转单审核数据
     * @param id 数据ID
     * @return
     */
    @Override
    public CommonResult deleteRepairTransferRecordById(int id) {
        RepairTransferRecord data = repairTransferRecordService.getRepairById(id);
        if (data == null) {
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = repairTransferRecordService.deleteRepairTransferRecordById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

